<?php include_once 'codebase/hyperframe.php' ?><h1>Multiple Sites</h1>

<h4>on the same shared server</h4>

<p>With Hyperframe it is quite permissible to host a number of sites in subdirectories of the same hosting space, in fact this is frequently necessary for testing purposes. There is no specific need to access the sites via a subdomain. A few points need to be noted about shared hosting though.&nbsp;</p>

<p>The login process requires that the session cookie is unique to each site hosted on the same domain. Otherwise, logins will clash. Therefore if you are not using subdomains, you should change the cookie string in sitecfg/siteini.php to make each cookie unique. This only matters if two sites will be administered at once from the same browser, so for development work it can generally be ignored, but for multiple production sites it is important.&nbsp;</p>

<p>It is also possible to host a complete subsite within the directory structure of a main hyperframe site, the subsite having its own codebase, menus, styles, etc. This is sometimes convenient when you wish to publish a &#39;minisite&#39; carrying information about a specific product, with a completely different style from the main site. The same considerations about the session cookie apply here.</p>
